dofile_once("data/scripts/lib/utilities.lua")
local entity_id = GetUpdatedEntityID()

local x, y, rot = EntityGetTransform(entity_id)

function get_player()
  local players = get_players()
  if players ~= nil then
	return players[1]
  end

  -- TODO: What does this mean anyway? Player is dead..?
  return nil
end

local player = get_player()
if player ~= nil then
	local px, py = EntityGetTransform(player)

	local max_px = tonumber(GlobalsGetValue("vehicles_max_player_x", px))

	local buildings_found = 0
	--( px > x + 500 ) or
	if max_px < x - 300  then
		for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
		  if EntityHasTag( child, "extinguished" ) == true then
			EntityKill(child)
		  end
		end
	end

	if px < x + 300 and px > x - 300 then
		for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
		  if EntityHasTag( child, "building" ) == true then
			if i > 1 then
				EntityKill(child)
			end
			if i == 1 then
				buildings_found = buildings_found + 1
			end
		  end
		end

		if buildings_found == 0 then
		
			local did_hit, did_hit_x, did_hit_y = RaytraceSurfacesAndLiquiform( x, y - 512, x, y + 512 )
			
			local buildings = {
					{
						file = "mods/vehicles/files/buildings/building1.xml",
						probability = 1.0,
					},
					{
						file = "mods/vehicles/files/buildings/building2.xml",
						probability = 1.0,
					},
					{
						file = "mods/vehicles/files/buildings/building3.xml",
						probability = 0.5,
					},
					-- {
						-- file = "mods/vehicles/files/buildings/building4.xml",
						-- probability = 0.25,
					-- },
				}

			local building = pick_random_from_table_weighted(random_create(x - entity_id, y), buildings)
			
			if did_hit == true then
				local vehicle = EntityLoad(building.file, did_hit_x, did_hit_y)
				local tx, ty = EntityGetTransform(vehicle)
				EntitySetTransform(entity_id, tx, ty)
				EntityAddChild(entity_id, vehicle)
			else
				local vehicle = EntityLoad(building.file, x, y + 512)
				local tx, ty = EntityGetTransform(vehicle)
				EntitySetTransform(entity_id, tx, ty)
				EntityAddChild(entity_id, vehicle)
			end
			
		end
		
	end
end