dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

function add_particle_emitter(material, count)
	local hitbox_components = EntityGetComponentIncludingDisabled(entity_id, "HitboxComponent")
	for _, comp in ipairs(hitbox_components) do
		local x_min = ComponentGetValue2( comp, "aabb_min_x" )
		local x_max = ComponentGetValue2( comp, "aabb_max_x" )
		local y_min = ComponentGetValue2( comp, "aabb_min_y" )
		local y_max = ComponentGetValue2( comp, "aabb_max_y" )
		
		local area = (x_max - x_min) * (y_max - y_min)
		local spawn_count = math.ceil(area / 10)
		
		local particle_comp = EntityAddComponent2(entity_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			count_min=4,
			count_max=14,
			x_pos_offset_min=x_min,
			y_pos_offset_min=y_min,
			x_pos_offset_max=x_max,
			y_pos_offset_max=y_max,
			x_vel_min=-10,
			x_vel_max=10,
			y_vel_min=-10,
			y_vel_max=10,
			count_min=spawn_count,
			count_max=spawn_count,
			lifetime_min=0.4,
			lifetime_max=1.0,
			create_real_particles=true,
			emit_cosmetic_particles=false,
			emission_interval_min_frames = 5,
			emission_interval_max_frames = 5,
			is_emitting=true
		} )
		
		local particle_comp = EntityAddComponent2(entity_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			custom_style="FIRE",
			count_min=4,
			count_max=14,
			x_pos_offset_min=x_min,
			y_pos_offset_min=y_min,
			x_pos_offset_max=x_max,
			y_pos_offset_max=y_max,
			x_vel_min=-10,
			x_vel_max=10,
			y_vel_min=-10,
			y_vel_max=10,
			count_min=spawn_count,
			count_max=spawn_count,
			lifetime_min=0.4,
			lifetime_max=1.0,
			create_real_particles=true,
			emit_cosmetic_particles=false,
			emission_interval_min_frames = 5,
			emission_interval_max_frames = 5,
			is_emitting=true
		} )
	end
end

add_particle_emitter("fire", 3)