dofile_once("data/scripts/lib/utilities.lua")
local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(entity_id)

function find_even_pos(start_x, start_y, step_distance, max_steps, max_slope)
  local x = start_x
  local last_hit_y
  for i=1,max_steps do
    local did_hit, hit_x, hit_y = RaytracePlatforms(x, start_y - 100, x, start_y + 200)
    if did_hit and not RaytracePlatforms(hit_x, hit_y - 2, hit_x, hit_y - 1) then
      if last_hit_y then
        local slope = math.abs(last_hit_y - hit_y)
        if slope < max_slope then
          return hit_x, hit_y
        end
      end
      last_hit_y = hit_y
    end
    x = start_x - step_distance * i
  end
end

local x, y = find_even_pos(x, y, 5, 100, 3)

if (not x) or (not y) or (x == 0) or (y == 0) then
    x, y, rot = EntityGetTransform(entity_id)
end

function get_direction( x1, y1, x2, y2 )
  return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
end

for i = 1, 100 do
	--Moving our normal detectors based on entity rotation
	local right_corner = { x1 = -67, y1 = 0 }
	local right_x, right_y = vec_rotate(right_corner.x1, right_corner.y1, rot)
	right_x = x + right_x
	right_y = y + right_y

	local left_corner = { x2 = 67, y2 = 0 }
	local left_x, left_y = vec_rotate(left_corner.x2, left_corner.y2, rot)
	left_x = x + left_x
	left_y = y + left_y

	local right_corner2 = { x1 = -33, y1 = 0 }
	local right_x2, right_y2 = vec_rotate(right_corner2.x1, right_corner2.y1, rot)
	right_x2 = x + right_x2
	right_y2 = y + right_y2

	local left_corner2 = { x2 = 33, y2 = 0 }
	local left_x2, left_y2 = vec_rotate(left_corner2.x2, left_corner2.y2, rot)
	left_x2 = x + left_x2
	left_y2 = y + left_y2

	normal_in_solid, hit_x, hit_y = RaytracePlatforms( right_x, right_y, right_x, right_y )
	normal_in_solid2, hit_x2, hit_y2 = RaytracePlatforms( left_x, left_y, left_x, left_y )
	normal_in_solid3, hit_x3, hit_y3 = RaytracePlatforms( x, y, x, y )
	normal_in_solid4, hit_x4, hit_y4 = RaytracePlatforms( right_x2, right_y2, right_x2, right_y2 )
	normal_in_solid5, hit_x5, hit_y5 = RaytracePlatforms( left_x2, left_y2, left_x2, left_y2 )

	points_in_solid = 0

	if normal_in_solid then
		points_in_solid = points_in_solid + 1
	end

	if normal_in_solid2 then
		points_in_solid = points_in_solid + 1
	end

	if normal_in_solid3 then
		points_in_solid = points_in_solid + 1
	end

	if normal_in_solid4 then
		points_in_solid = points_in_solid + 1
	end

	if normal_in_solid4 then
		points_in_solid = points_in_solid + 1
	end

	if points_in_solid > 0 then
		y = y - 1
	end
end


local found_normal, normal_x, normal_y, approximate_distance_from_surface = GetSurfaceNormal(right_x, right_y, 100, 16)
local found_normal2, normal_x2, normal_y2, approximate_distance_from_surface = GetSurfaceNormal(left_x, left_y, 100, 16)
local found_normal3, normal_x3, normal_y3, approximate_distance_from_surface3 = GetSurfaceNormal(x, y, 100, 16)
local found_normal4, normal_x4, normal_y4, approximate_distance_from_surface = GetSurfaceNormal(right_x2, right_y2, 100, 16)
local found_normal5, normal_x5, normal_y5, approximate_distance_from_surface = GetSurfaceNormal(left_x2, left_y2, 100, 16)

normal_count = 5

if normal_in_solid or not found_normal then
	normal_x = 0
	normal_y = 0
	normal_count = normal_count - 1
end

if normal_in_solid2 or not found_normal2 then
	normal_x2 = 0
	normal_y2 = 0
	normal_count = normal_count - 1
end

if normal_in_solid3 or not found_normal3 then
	normal_x3 = 0
	normal_y3 = 0
	normal_count = normal_count - 1
end

if normal_in_solid4 or not found_normal4 then
	normal_x4 = 0
	normal_y4 = 0
	normal_count = normal_count - 1
end

if normal_in_solid5 or not found_normal5 then
	normal_x5 = 0
	normal_y5 = 0
	normal_count = normal_count - 1
end
	
if normal_count > 0 then

	local normal_x_average = (normal_x + normal_x2 + normal_x3 + normal_x4 + normal_x5) / normal_count
	local normal_y_average = (normal_y + normal_y2 + normal_y3 + normal_y4 + normal_y5) / normal_count

	local dir = get_direction(0, 0, normal_x_average, normal_y_average)
	local degree_shift = math.rad(-90) + dir 
	
	local vehicle = EntityLoad("mods/vehicles/files/fire_truck/fire_truck.xml", x, y - 30)
	local tx, ty = EntityGetTransform(vehicle)

	local deg_var_comp = get_variable_storage_component( vehicle, "degrees" )
	ComponentSetValue2(deg_var_comp, "value_float", degree_shift )
else
	local vehicle = EntityLoad("mods/vehicles/files/fire_truck/fire_truck.xml", x, y - 30)
end

EntityKill(entity_id)