dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y, r = EntityGetTransform(entity_id)

local truck_entity = EntityGetRootEntity( entity_id )
local tx, ty, truck_rotation = EntityGetTransform(truck_entity)
local gun_base = EntityGetParent( entity_id )
local gx, gy = EntityGetTransform(gun_base)
local aim_x, aim_y = DEBUG_GetMouseWorld()

--here we rotate the hose towards the mouse
local angle = math.atan2(aim_y - gy, aim_x - gx)
EntitySetTransform(entity_id, gx - 1, gy + 4, angle)


--Here we shoot when mouse is clicked
function is_button_down(button)
  local player = EntityGetWithTag("player_unit")[1]
  if player then
    local controls_comp = EntityGetFirstComponentIncludingDisabled(player, "ControlsComponent")
    return ComponentGetValue2(controls_comp, "mButtonDown" .. button)
  end
end

if is_button_down("LeftClick") then
	local dir_x = math.cos(r)
	local dir_y = math.sin(r)
	local vel_x, vel_y = GameGetVelocityCompVelocity( truck_entity )
	shoot_projectile(entity_id, "mods/vehicles/files/fire_truck/flame_beam.xml", x + (vel_x * 0.03) + dir_x * 20, y + (vel_y * 0.03) + dir_y * 20, dir_x * 600, dir_y * 600, true)
end

local max_px = tonumber(GlobalsGetValue("vehicles_max_player_x", tx))
if tx > max_px then
	GlobalsSetValue("vehicles_max_player_x", tx)
end

if tonumber(GlobalsGetValue("saved_buildings", "0")) >= 20 then
	GlobalsSetValue("vehicles_enough_buildings_saved", 1)
end
--Buildings saved %
--GUI
if GlobalsGetValue("vehicles_enough_buildings_saved", "0") == "0" then

	if GlobalsGetValue("vehicles_respawn_in_progress", "0") == "0" then
		gui = gui or GuiCreate()
		GuiStartFrame(gui)
		local screen_width, screen_height = GuiGetScreenDimensions(gui)
		local healthbar_width = (30)
		local healthbar_height = 2
		local healthbar_offset_y = screen_height * 0.213889 -18
		local hp_max = 100
		local hp = math.floor(( tonumber(GlobalsGetValue("saved_buildings", "0")) / 20 ) * 100) -- SET YOUR HP HEEEEEEEEEEEEEREEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
		if hp < 0 then
		  return
		end

		local percent_filled = hp / hp_max
		local inner_healthbar_width = (healthbar_width) * percent_filled
		-- Outline / Background
		GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
		GuiZSetForNextWidget(gui, -100)
		GuiImage(gui, 2, (screen_width / 2) - (healthbar_width), screen_height - healthbar_offset_y - 8, "data/ui_gfx/hud/colors_health_bar_damage.png", 1, healthbar_width, healthbar_height) -- 20x20
		-- Actual inner bar
		GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
		GuiZSetForNextWidget(gui, -101)
		GuiImage(gui, 3, (screen_width / 2) - (healthbar_width), screen_height - healthbar_offset_y - 8, "data/ui_gfx/hud/colors_health_bar.png", 1, inner_healthbar_width, healthbar_height) -- 20x20
		-- Health icon
		GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
		GuiZSetForNextWidget(gui, -102)
		GuiImage(gui, 4, (screen_width / 2 ) + ( healthbar_width / 2 ) + 17, screen_height - healthbar_offset_y - 10, "data/ui_gfx/hud/health.png", 1, 1, 1)
		-- Text
		local text_width = GuiGetTextDimensions(gui, hp .. "% Saved", 1)
		GuiColorSetForNextWidget(gui, 1, 1, 1, 1)
		GuiZSetForNextWidget(gui, -103)
		GuiText(gui, (screen_width / 2) - (text_width / 2), screen_height - healthbar_offset_y - 1, hp .. "% Saved")
	
	
		-- Timer
		local time_elapsed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
		if time_elapsed >= 4500 then

			local phrases = { "Mission Failed", "Try Again" }
			SetRandomSeed(GameGetFrameNum(), GameGetFrameNum())
			GamePrintImportant(phrases[Random(1, #phrases)], "You're too Late!")
			EntitySetComponentsWithTagEnabled(truck_entity, "controls", false)
			GamePlaySound( "data/audio/Desktop/event_cues.bank", "event_cues/angered_the_gods/create", tx, ty )
			GlobalsSetValue("vehicles_respawn_in_progress", "1")
			SetTimeOut(4, "mods/vehicles/files/restart.lua", "clear")
			SetTimeOut(5, "mods/vehicles/files/restart.lua", "respawn")

		end

		--Timer GUI
		gui = gui or GuiCreate()
		GuiStartFrame(gui)
		local screen_width, screen_height = GuiGetScreenDimensions(gui)
		local healthbar_width = (50)
		local healthbar_height = 2
		local healthbar_offset_y = screen_height * 0.213889 -40
		local hp_max = 100
		local hp = 100 - math.floor(( time_elapsed / 4500 ) * 100) -- SET YOUR HP HEEEEEEEEEEEEEREEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
		if hp < 0 then
		  return
		end

		local percent_filled = hp / hp_max
		local inner_healthbar_width = (healthbar_width) * percent_filled
		-- Outline / Background
		GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
		GuiZSetForNextWidget(gui, -100)
		GuiImage(gui, 2, (screen_width / 2) - (healthbar_width), screen_height - healthbar_offset_y - 8, "data/ui_gfx/hud/colors_health_bar_damage.png", 1, healthbar_width, healthbar_height) -- 20x20
		-- Actual inner bar
		GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
		GuiZSetForNextWidget(gui, -101)
		GuiImage(gui, 3, (screen_width / 2) - (healthbar_width), screen_height - healthbar_offset_y - 8, "data/ui_gfx/hud/colors_mana_bar.png", 1, inner_healthbar_width, healthbar_height) -- 20x20
		-- Health icon
		GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
		GuiZSetForNextWidget(gui, -102)
		GuiImage(gui, 4, (screen_width / 2 ) + ( healthbar_width / 2 ) + 30, screen_height - healthbar_offset_y - 10, "mods/vehicles/files/fire_truck/time.png", 1, 1, 1)
		-- Text
		local text_width = GuiGetTextDimensions(gui, "Time", 1)
		GuiColorSetForNextWidget(gui, 1, 1, 1, 1)
		GuiZSetForNextWidget(gui, -103)
		GuiText(gui, (screen_width / 2) - (text_width / 2), screen_height - healthbar_offset_y - 1, "Time")
	end
end