dofile_once("data/scripts/lib/utilities.lua")

function get_torque(current_angle, target_angle, speed)
	-- Make angle go from 0 to 2pi
	if target_angle < 0 then
	  target_angle = target_angle + math.pi * 2
	end
	if current_angle < 0 then
	  current_angle = current_angle + math.pi * 2
	end
  
	local dist_up = math.abs(target_angle - current_angle)
	local dist_down = math.abs((current_angle + math.pi * 2) - target_angle)
	
	if current_angle > target_angle then
	  dist_up = math.abs((target_angle + math.pi * 2) - current_angle)
	  dist_down = math.abs(current_angle - target_angle)
	end
	
	local dir
	if math.abs(dist_up) < math.abs(dist_down) then
	  dir = 1
	else
	  dir = -1
	end
	local dist_smallest = dist_up
	if dist_down < dist_up then
	  dist_smallest = dist_down
	end
  
	local new_angle = speed * dir

	return new_angle
end

local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(entity_id)

local controls_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")
local up_down = ComponentGetValue2(controls_component, "mButtonDownUp")
local down_down = ComponentGetValue2(controls_component, "mButtonDownDown")
local left_down = ComponentGetValue2(controls_component, "mButtonDownLeft")
local right_down = ComponentGetValue2(controls_component, "mButtonDownRight")
local nx = math.cos(rot)
local ny = math.sin(rot)

local max_speed = 900
local leaning_power = 300

local phys_body = EntityGetFirstComponent(entity_id, "PhysicsBodyComponent")
local mass = ComponentGetValue2(phys_body, "mPixelCount")

local multiplier = 200
if up_down then
	multiplier = 350
end
--Move Forward
if not down_down then
	PhysicsApplyForce(entity_id, nx * multiplier, ny * multiplier)
	PhysicsApplyForce(entity_id, 0, -100)
end

--Rotate Towards Mouse
local aim_x, aim_y = DEBUG_GetMouseWorld()
local angle = math.atan2( (aim_y - y), (aim_x - x) )
local ang_vel = PhysicsGetComponentAngularVelocity( entity_id, phys_body )
PhysicsApplyTorque(entity_id, get_torque(rot, angle, 1000))
PhysicsApplyTorque(entity_id, -ang_vel)
  
function is_button_down(button)
  local player = EntityGetWithTag("player_unit")[1]
  if player then
    local controls_comp = EntityGetFirstComponentIncludingDisabled(player, "ControlsComponent")
    return ComponentGetValue2(controls_comp, "mButtonDown" .. button)
  end
end

if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 4 == 0 then
	if is_button_down("LeftClick") then

		rotate_value = 0
		
		rotation = rot - math.rad(rotate_value)
		local distance_from_center = 35
		local projectile_speed = 1000
		-- SetRandomSeed(GameGetFrameNum(), x + y * i)
		-- local random_angle_adjustment = math.rad(Random(-60, 60))
		local target_x = x + math.cos(rotation) * distance_from_center
		local target_y = y + 10 + math.sin(rotation) * distance_from_center
		
		local vel_x = math.cos(rotation) * projectile_speed
		local vel_y = math.sin(rotation) * projectile_speed
			
		local vel_x2, vel_y2 = GameGetVelocityCompVelocity( entity_id )
		shoot_projectile(entity_id, "mods/vehicles/files/plane/machinegun_bullet_tank.xml", target_x, target_y, vel_x, vel_y, true)
	end
end

if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 60 == 0 then
	if is_button_down("RightClick") then

		rotate_value = 90
		
		rotation = rot - math.rad(rotate_value)
		local distance_from_center = 10
		local projectile_speed = 350
		-- SetRandomSeed(GameGetFrameNum(), x + y * i)
		-- local random_angle_adjustment = math.rad(Random(-60, 60))
		local target_x = x + math.cos(rotation) * distance_from_center
		local target_y = y + 30 + math.sin(rotation) * distance_from_center
		
		local vel_x = math.cos(rotation) * projectile_speed
		local vel_y = math.sin(rotation) * projectile_speed
			
		local vel_x2, vel_y2 = GameGetVelocityCompVelocity( entity_id )
		shoot_projectile(entity_id, "mods/vehicles/files/plane/bazooka.xml", target_x, target_y, 0, 0, true)
	end
end