dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()

local x, y, rot = EntityGetTransform(entity_id)

if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") == 1 then
	GlobalsSetValue("vehicles_respawn_in_progress", "0")
end

if x > 70000 and x < 72500 and ( GlobalsGetValue("vehicles_helicopters_done", "0") == "0" ) then
	GlobalsSetValue("vehicles_respawn_x", 70000)
	GlobalsSetValue("vehicles_respawn_y", -500)
	
	local dialogue = EntityLoad("mods/vehicles/files/plane/dialogue2.xml", x, y )
	GlobalsSetValue("vehicles_helicopters_done", "1")
end

if x > 73500 and x < 75000 and ( GlobalsGetValue("vehicles_ufos_start", "0") == "0" ) then
	
	local dialogue = EntityLoad("mods/vehicles/files/plane/dialogue3.xml", x, y )
	GlobalsSetValue("vehicles_ufos_start", "1")
end

if x > 83600 and ( GlobalsGetValue("vehicles_ufos_finish", "0") == "0" ) then
	
	local dialogue = EntityLoad("mods/vehicles/files/plane/dialogue4.xml", x, y )
	EntityAddChild(entity_id, dialogue)
	
	local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
	EntitySetComponentIsEnabled( entity_id, damage_model_component, false )
	
	GlobalsSetValue("vehicles_level5", "1")
	GlobalsSetValue("vehicles_respawn_x", 90600)
	GlobalsSetValue("vehicles_respawn_y", -100)
	
	GlobalsSetValue("vehicles_ufos_finish", "1")
	
end

--HP GUI
local parent_damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
local parent_health = ComponentGetValue2(parent_damage_model_component, "hp")

if parent_health < 1.5 then
	EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", true)
else
	EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
end

if GlobalsGetValue("vehicles_level5", "0") == "0" then
	gui = gui or GuiCreate()
	GuiStartFrame(gui)
	local screen_width, screen_height = GuiGetScreenDimensions(gui)
	local healthbar_width = (30)
	local healthbar_height = 2
	local healthbar_offset_x = 40
	local healthbar_offset_y = screen_height * 0.213889 -40
	local hp_max = 100
	local hp = math.floor(( parent_health / 4 ) * 100) -- SET YOUR HP HEEEEEEEEEEEEEREEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
	if hp < 0 then
	  return
	end

	local percent_filled = hp / hp_max
	local inner_healthbar_width = (healthbar_width) * percent_filled
	-- Outline / Background
	GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
	GuiZSetForNextWidget(gui, -100)
	GuiImage(gui, 2, (screen_width / 2) - (healthbar_width) + healthbar_offset_x, screen_height - healthbar_offset_y - 8, "data/ui_gfx/hud/colors_health_bar_damage.png", 1, healthbar_width, healthbar_height) -- 20x20
	-- Actual inner bar
	GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
	GuiZSetForNextWidget(gui, -101)
	GuiImage(gui, 3, (screen_width / 2) - (healthbar_width) + healthbar_offset_x, screen_height - healthbar_offset_y - 8, "data/ui_gfx/hud/colors_health_bar.png", 1, inner_healthbar_width, healthbar_height) -- 20x20
	-- Health icon
	GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
	GuiZSetForNextWidget(gui, -102)
	GuiImage(gui, 4, (screen_width / 2 ) + ( healthbar_width / 2 ) + 17 + healthbar_offset_x, screen_height - healthbar_offset_y - 10, "data/ui_gfx/hud/health.png", 1, 1, 1)
	-- Text
	local text_width = GuiGetTextDimensions(gui, hp, 1)
	GuiColorSetForNextWidget(gui, 1, 1, 1, 1)
	GuiZSetForNextWidget(gui, -103)
	GuiText(gui, (screen_width / 2) - (text_width / 2) + healthbar_offset_x, screen_height - healthbar_offset_y - 1, hp .. "%")
	
	-- Right Movement Indicator
	local cx, cy = GameGetCameraPos()
	GameCreateSpriteForXFrames( "mods/vehicles/files/plane/indicator_right.png", cx + 150, cy, true, 0, 0, 1, true )
	-- GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
	-- GuiZSetForNextWidget(gui, -102)
	-- GuiImage(gui, 4, (screen_width / 2 ) + 220, ( screen_height / 2 ) + 9, "mods/vehicles/files/plane/indicator_right.png", 1, 1, 1)
	
	--Distance GUI
	gui = gui or GuiCreate()
	GuiStartFrame(gui)
	local screen_width, screen_height = GuiGetScreenDimensions(gui)
	local healthbar_width = (30)
	local healthbar_height = 2
	local healthbar_offset_y = screen_height * 0.213889 -40
	local distance_max = 48450
	local distance = math.max(0, x - 35150) -- SET YOUR DISTANCE HEEEEEEEEEEEEEREEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
	if distance < 0 then
	  return
	end

	local percent_filled = distance / distance_max
	local inner_healthbar_width = (healthbar_width) * percent_filled
	-- Outline / Background
	GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
	GuiZSetForNextWidget(gui, -100)
	GuiImage(gui, 2, (screen_width / 2) - (healthbar_width) - healthbar_offset_x, screen_height - healthbar_offset_y - 8, "data/ui_gfx/hud/colors_health_bar_damage.png", 1, healthbar_width, healthbar_height) -- 20x20
	-- Actual inner bar
	GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
	GuiZSetForNextWidget(gui, -101)
	GuiImage(gui, 3, (screen_width / 2) - (healthbar_width) - healthbar_offset_x, screen_height - healthbar_offset_y - 8, "data/ui_gfx/hud/colors_mana_bar.png", 1, inner_healthbar_width, healthbar_height) -- 20x20
	
	-- Treshold Mark
	GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
	GuiZSetForNextWidget(gui, -102)
	GuiImage(gui, 3, (screen_width / 2) + (healthbar_width * 0.4) - healthbar_offset_x, screen_height - healthbar_offset_y - 8, "data/ui_gfx/hud/colors_flying_bar.png", 1, 2, healthbar_height) -- 20x20
	
	-- Text
	local text_width = GuiGetTextDimensions(gui, "Distance", 1)
	GuiColorSetForNextWidget(gui, 1, 1, 1, 1)
	GuiZSetForNextWidget(gui, -103)
	GuiText(gui, (screen_width / 2) - (text_width / 2) - healthbar_offset_x, screen_height - healthbar_offset_y - 1, "Distance")
end

--ENEMY RADAR

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform( entity_id )
pos_y = pos_y - 4 -- offset to middle of character

local range = 600
local indicator_distance = 512

-- ping nearby enemies
for _,enemy_id in pairs(EntityGetInRadiusWithTag( pos_x, pos_y, range, "helicopter")) do
	local enemy_x, enemy_y = EntityGetFirstHitboxCenter(enemy_id)
	local dir_x = enemy_x - pos_x
	local dir_y = enemy_y - pos_y
	local distance = get_magnitude(dir_x, dir_y)

	local indicator_x = 0
	local indicator_y = 0

	if is_in_camera_bounds(enemy_x, enemy_y, -4) then
		indicator_x = enemy_x
		indicator_y = enemy_y - 3
	else
		-- position radar indicators around character
		dir_x,dir_y = vec_normalize(dir_x,dir_y)
		indicator_x = pos_x + dir_x * indicator_distance
		indicator_y = pos_y + dir_y * indicator_distance
	end
	
	local cx, cy = GameGetCameraPos()
	if (indicator_x > cx + 140) then
		indicator_x = cx + 140
	end
	
	if (indicator_x < cx - 140) then
		indicator_x = cx - 140
	end
	
	if (indicator_y < cy - 100) then
		indicator_y = cy - 100
	end
	
	if (indicator_y > cy + 100) then
		indicator_y = cy + 100
	end

	-- display sprite based on proximity
	if distance > range * 0.8 then
		GameCreateSpriteForXFrames( "mods/vehicles/files/plane/indicator_faint.png", indicator_x, indicator_y, true, 0, 0, 1, true )
	elseif distance > range * 0.5 then
		GameCreateSpriteForXFrames( "mods/vehicles/files/plane/indicator_medium.png", indicator_x, indicator_y, true, 0, 0, 1, true )
	else
		GameCreateSpriteForXFrames( "mods/vehicles/files/plane/indicator_strong.png", indicator_x, indicator_y, true, 0, 0, 1, true )
	end
end
