dofile_once("data/scripts/lib/utilities.lua")

function get_torque(current_angle, target_angle, speed)
	-- Make angle go from 0 to 2pi
	if target_angle < 0 then
	  target_angle = target_angle + math.pi * 2
	end
	if current_angle < 0 then
	  current_angle = current_angle + math.pi * 2
	end
  
	local dist_up = math.abs(target_angle - current_angle)
	local dist_down = math.abs((current_angle + math.pi * 2) - target_angle)
	
	if current_angle > target_angle then
	  dist_up = math.abs((target_angle + math.pi * 2) - current_angle)
	  dist_down = math.abs(current_angle - target_angle)
	end
	
	local dir
	if math.abs(dist_up) < math.abs(dist_down) then
	  dir = 1
	else
	  dir = -1
	end
	local dist_smallest = dist_up
	if dist_down < dist_up then
	  dist_smallest = dist_down
	end
  
	local new_angle = speed * dir

	return new_angle
end

local this_entity = GetUpdatedEntityID()

local x, y, r = EntityGetTransform(this_entity)

local variable_storage = get_variable_storage_component( this_entity, "degrees" )
local degrees = tonumber(ComponentGetValue2( variable_storage, "value_float" ))

local phys_body = EntityGetFirstComponent(this_entity, "PhysicsBody2Component")
local mass = ComponentGetValue2(phys_body, "mPixelCount")

if GlobalsGetValue("vehicles_crate_spawned", "0") == "0" then
	local did_hit, did_hit_x, did_hit_y = RaytraceSurfacesAndLiquiform( x - 100, y - 512, x - 100, y + 512 )
	if did_hit then
		local ent = EntityLoad("mods/vehicles/files/quad_bike/crate.xml", did_hit_x, did_hit_y - 45)
		EntityAddChild(this_entity, ent)
		GlobalsSetValue("vehicles_crate_spawned", "1")
	else
		local ent = EntityLoad("mods/vehicles/files/quad_bike/crate.xml", x - 100, y - 60)
		EntityAddChild(this_entity, ent)
		GlobalsSetValue("vehicles_crate_spawned", "1")
	end
end

if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") < 50 then

	PhysicsSetStatic(this_entity, true)
	PhysicsSetStatic(this_entity, false)

	PhysicsApplyTorque( this_entity, get_torque(r, degrees, 5) * mass )
	
elseif ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") < 60 then

	EntitySetComponentsWithTagEnabled(this_entity, "controls", true)
	PhysicsSetStatic(this_entity, true)
	PhysicsSetStatic(this_entity, false)
	
	GlobalsSetValue("vehicles_respawn_in_progress", "0")
	
end

