dofile_once("data/scripts/lib/utilities.lua")

function clear()

	local entities = EntityGetInRadiusWithTag(0, 0, 999999999999999999999999, "vehicle")

	for i, entity in ipairs(entities) do
		local x, y, rot = EntityGetTransform(entity)
		EntityKill(entity)
		EntityLoad("mods/vehicles/files/truck/clear_tires.xml", x, y)
	end
	
end

function clear_tires()

	local entities = EntityGetInRadiusWithTag(0, 0, 999999999999999999999999, "vehicle")

	for i, entity in ipairs(entities) do
		local x, y, rot = EntityGetTransform(entity)
		EntityLoad("mods/vehicles/files/truck/clear_tires.xml", x, y)
	end
	
end

function fire_plane_dialogue()
	local respawn_x = tonumber(GlobalsGetValue("vehicles_respawn_x", MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_X" )))
	local respawn_y = tonumber(GlobalsGetValue("vehicles_respawn_y", MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_Y" )))
	if GlobalsGetValue("vehicles_plane_start_dialogue_fired", "0") == "0" then
		EntityLoad("mods/vehicles/files/plane/dialogue.xml", respawn_x, respawn_y )
		GlobalsSetValue("vehicles_plane_start_dialogue_fired", 1)
	end
end

function respawn()
	if GlobalsGetValue("vehicles_respawn_in_progress", "0") == "1" then
		if GlobalsGetValue("vehicles_level1", "0") == "0" then
			local respawn_x = tonumber(GlobalsGetValue("vehicles_respawn_x", MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_X" )))
			local respawn_y = tonumber(GlobalsGetValue("vehicles_respawn_y", MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_Y" )))
			EntityLoad("mods/vehicles/files/truck/truck_spawner.xml", respawn_x, respawn_y )
		elseif GlobalsGetValue("vehicles_level2", "0") == "0" then
			local respawn_x = tonumber(GlobalsGetValue("vehicles_respawn_x", MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_X" )))
			local respawn_y = tonumber(GlobalsGetValue("vehicles_respawn_y", MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_Y" )))
			EntityLoad("mods/vehicles/files/quad_bike/quad_bike_spawner.xml", respawn_x, respawn_y )
			GlobalsSetValue("vehicles_crate_spawned", "0")
		elseif GlobalsGetValue("vehicles_level3", "0") == "0" then
			local respawn_x = tonumber(GlobalsGetValue("vehicles_respawn_x", MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_X" )))
			local respawn_y = tonumber(GlobalsGetValue("vehicles_respawn_y", MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_Y" )))
			EntityLoad("mods/vehicles/files/fire_truck/fire_truck_spawner.xml", respawn_x, respawn_y )
			if GlobalsGetValue("vehicles_enough_buildings_saved", "0") == "0" then
				GlobalsSetValue("saved_buildings", 0)
				GlobalsSetValue("vehicles_max_player_x", respawn_x)
			end
		elseif GlobalsGetValue("vehicles_level4", "0") == "0" then
			local respawn_x = tonumber(GlobalsGetValue("vehicles_respawn_x", MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_X" )))
			local respawn_y = tonumber(GlobalsGetValue("vehicles_respawn_y", MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_Y" )))
			EntityLoad("mods/vehicles/files/speed_boat/speed_boat_spawner.xml", respawn_x, respawn_y )
		elseif GlobalsGetValue("vehicles_level5", "0") == "0" then
			local respawn_x = tonumber(GlobalsGetValue("vehicles_respawn_x", MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_X" )))
			local respawn_y = tonumber(GlobalsGetValue("vehicles_respawn_y", MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_Y" )))
			EntityLoad("mods/vehicles/files/plane/plane.xml", respawn_x, respawn_y )
			SetTimeOut(5, "mods/vehicles/files/restart.lua", "fire_plane_dialogue")
		elseif GlobalsGetValue("vehicles_game_finished", "0") == "0" then
			local respawn_x = tonumber(GlobalsGetValue("vehicles_respawn_x", MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_X" )))
			local respawn_y = tonumber(GlobalsGetValue("vehicles_respawn_y", MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_Y" )))
			EntityLoad("mods/vehicles/files/rocket/rocket_spawner.xml", respawn_x, respawn_y )
		end
		GameTriggerMusicFadeOutAndDequeueAll()
	end
end

function damage_received(damage, message, entity_thats_responsible, is_fatal)
  if is_fatal then
	if GlobalsGetValue("vehicles_respawn_in_progress", "0") == "0" then
		local entity_id = GetUpdatedEntityID()
		local root_id = EntityGetRootEntity(entity_id)
		local rx, ry= EntityGetTransform(root_id)
		local phrases = { "Mission Failed", "Try Again" }
		SetRandomSeed(GameGetFrameNum(), GameGetFrameNum())
		GamePrintImportant(phrases[Random(1, #phrases)], "Your vehicle exploded!")
		EntitySetComponentsWithTagEnabled(root_id, "controls", false)
		GamePlaySound( "data/audio/Desktop/event_cues.bank", "event_cues/angered_the_gods/create", rx, ry )
		GlobalsSetValue("vehicles_respawn_in_progress", "1")
		clear_tires()
		SetTimeOut(5, "mods/vehicles/files/restart.lua", "respawn")
	end
  end
end