dofile_once("data/scripts/lib/utilities.lua")

--Floating

function get_torque(current_angle, target_angle, speed)
	-- Make angle go from 0 to 2pi
	if target_angle < 0 then
	  target_angle = target_angle + math.pi * 2
	end
	if current_angle < 0 then
	  current_angle = current_angle + math.pi * 2
	end
  
	local dist_up = math.abs(target_angle - current_angle)
	local dist_down = math.abs((current_angle + math.pi * 2) - target_angle)
	
	if current_angle > target_angle then
	  dist_up = math.abs((target_angle + math.pi * 2) - current_angle)
	  dist_down = math.abs(current_angle - target_angle)
	end
	
	local dir
	if math.abs(dist_up) < math.abs(dist_down) then
	  dir = 1
	else
	  dir = -1
	end
	local dist_smallest = dist_up
	if dist_down < dist_up then
	  dist_smallest = dist_down
	end
  
	local new_angle = speed * dir

	return new_angle
end

corners_in_water = 0

local entity_id = GetUpdatedEntityID()

local x, y, rot = EntityGetTransform( entity_id )

--corners
local top_left_corner = { x = -12, y = 0 }
local top_left_x, top_left_y = vec_rotate(top_left_corner.x, top_left_corner.y, rot)
top_left_x = x + top_left_x
top_left_y = y + top_left_y

local bottom_left_corner = { x = -31, y = 16 }
local bottom_left_x, bottom_left_y = vec_rotate(bottom_left_corner.x, bottom_left_corner.y, rot)
bottom_left_x = x + bottom_left_x
bottom_left_y = y + bottom_left_y

local top_right_corner = { x = 31, y = 2 }
local top_right_x, top_right_y = vec_rotate(top_right_corner.x, top_right_corner.y, rot)
top_right_x = x + top_right_x
top_right_y = y + top_right_y

local bottom_right_corner = { x = 20, y = 16 }
local bottom_right_x, bottom_right_y = vec_rotate(bottom_right_corner.x, bottom_right_corner.y, rot)
bottom_right_x = x + bottom_right_x
bottom_right_y = y + bottom_right_y

--edges
local top_edge = { x = 8, y = -1 }
local top_edge_x, top_edge_y = vec_rotate(top_edge.x, top_edge.y, rot)
top_edge_x = x + top_edge_x
top_edge_y = y + top_edge_y

local bottom_edge = { x = -5, y = 17 }
local bottom_edge_x, bottom_edge_y = vec_rotate(bottom_edge.x, bottom_edge.y, rot)
bottom_edge_x = x + bottom_edge_x
bottom_edge_y = y + bottom_edge_y

local right_edge = { x = -22, y = 6 }
local right_edge_x, right_edge_y = vec_rotate(right_edge.x, right_edge.y, rot)
right_edge_x = x + right_edge_x
right_edge_y = y + right_edge_y

local left_edge = { x = 28, y = 13 }
local left_edge_x, left_edge_y = vec_rotate(left_edge.x, left_edge.y, rot)
left_edge_x = x + left_edge_x
left_edge_y = y + left_edge_y

function corner_in_liquid(corner_x, corner_y)

    local corner_in_water, hit_x, hit_y = RaytraceSurfacesAndLiquiform( corner_x, corner_y, corner_x, corner_y )
    local corner_in_solid, hit_x2, hit_y2 = RaytracePlatforms( corner_x, corner_y, corner_x, corner_y )

    if corner_in_water and not corner_in_solid then
        corners_in_water = corners_in_water + 1
    end
    
end

corner_in_liquid(top_left_x, top_left_y)
corner_in_liquid(top_right_x, top_right_y)
corner_in_liquid(bottom_left_x, bottom_left_y)
corner_in_liquid(bottom_right_x, bottom_right_y)

corner_in_liquid(top_edge_x, top_edge_y)
corner_in_liquid(bottom_edge_x, bottom_edge_y)
corner_in_liquid(left_edge_x, left_edge_y)
corner_in_liquid(right_edge_x, right_edge_y)

local phys_body = EntityGetFirstComponent(entity_id, "PhysicsBody2Component")
local mass = ComponentGetValue2(phys_body, "mPixelCount")

local floating = false

if corners_in_water > 3 then
    -- PhysicsApplyTorque(entity_id, -rot * 3)
    PhysicsApplyForce(entity_id, 0, -140)
	PhysicsApplyTorque(entity_id, get_torque(rot, 0, 0.1) * mass )
	floating = true
end


local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(entity_id)

local controls_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")
local up_down = ComponentGetValue2(controls_component, "mButtonDownUp")
local down_down = ComponentGetValue2(controls_component, "mButtonDownDown")
local left_down = ComponentGetValue2(controls_component, "mButtonDownLeft")
local right_down = ComponentGetValue2(controls_component, "mButtonDownRight")
local nx = math.cos(rot)
local ny = math.sin(rot)

local max_speed = 900
local leaning_power = 600

  if up_down and ( floating == true ) then
    PhysicsApplyForce(entity_id, nx * 1800, -ny * 50)
	PhysicsApplyForce(entity_id, 0, -100)
	PhysicsApplyTorque(entity_id, get_torque(rot, rot - 0.01, 1) * mass )
  elseif down_down and ( floating == true ) then
    PhysicsApplyForce(entity_id, nx * -1800, -ny * 50)
	PhysicsApplyForce(entity_id, 0, -100)
	PhysicsApplyTorque(entity_id, get_torque(rot, rot + 0.01, 1) * mass )
	-- PhysicsApplyTorque(entity_id, -leaning_power)
  end
  if left_down then
    PhysicsApplyTorque(entity_id, -leaning_power)
  elseif right_down then
    PhysicsApplyTorque(entity_id, leaning_power)
  end