dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform( entity_id )

local enemy_found = false

for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do

  if EntityHasTag( child, "helicopter" ) == true then
	if i > 1 then
		EntityKill(child)
		return
	else
		enemy_found = true
		enemy_id = child
	end
	
  end
  
end

local entities = EntityGetInRadiusWithTag( pos_x, pos_y, 100, "helicopter" )
for i, entity in ipairs(entities or {}) do
	if #entities > 1 then
		EntityKill(entity)
	end
end

if GlobalsGetValue("vehicles_respawn_in_progress", "0") == "1" then

	if enemy_found == true then
		local entity_id = GetUpdatedEntityID()
		
		EntityAddComponent( enemy_id, "LuaComponent", 
		{ 
			script_source_file="mods/vehicles/files/kill_on_timer.lua",
			execute_every_n_frame = "240"
		} )
	end
	
elseif GlobalsGetValue("vehicles_respawn_in_progress", "0") == "0" then
	local player_id = get_players()[1]
	if (player_id ~= nil) then
		local px, py = EntityGetTransform( player_id )
		local dist = get_distance(pos_x, pos_y, px, py)
		if (enemy_found == false ) and dist > 350 then
			
			local props = {
				{
					file = "mods/vehicles/files/ufo/ufo_spawner2.xml",
					probability = 1.0,
				},
				-- {
					-- file = "data/entities/props/overworld/sand_pile_02.xml",
					-- probability = 1.0,
				-- },
				-- {
					-- file = "data/entities/props/overworld/desert_ruins_spawner.xml",
					-- probability = 0.6,
				-- },
			}

			local prop = pick_random_from_table_weighted(random_create(pos_x - entity_id, pos_y), props)
			local enemy_child = EntityLoad(prop.file, pos_x, pos_y)
			EntityAddChild(entity_id, enemy_child)
		end
	end
end

