dofile_once("data/scripts/lib/utilities.lua")

ModMagicNumbersFileAdd("mods/vehicles/files/magic_numbers.xml")
ModMaterialsFileAdd("mods/vehicles/files/materials/materials.xml")

--Adding Custom Translations
local contents = ModTextFileGetContent("data/translations/common.csv")
local languages = { "en", "ru", "pt-br", "es-es", "de", "fr-fr", "it", "pl", "zh-cn", "jp", "k", }

function add_translation_string(id, translations)
  contents = contents .. id .. ","
  for i, language in ipairs(languages) do
    if translations[language] then
      contents = contents .. "\"" .. translations[language]:gsub("\n", "\\n") .. "\","
    else
      contents = contents .. ","
    end
  end
  contents = contents .. ",,,\n"
end

--Please notice how dialogues have special spacing with several spaces and a couple of enters. This is important
--Normal names do not have that special spacing (If you don't understand it well, I can fix it later)

add_translation_string("vehicles_uncle_ben_name", {
  en = [[Uncle Ben]],
  jp = [[ベン]],
  ru = [[Дядя Бен]]
})

add_translation_string("vehicles_uncle_ben_dialogue_start", {
  en = [[
    {@delay 2}Hello son. Been a while since I last called you
    I need some fossil fuels to power my wood chipper {@pause 30}
    Would you mind bringing some over with your truck?
	Thanks!
  ]],
  jp = [[
    {@delay 2}よく来てくれた。早速だが頼みがある。{@pause 30}
    ガソリンが足りないんだ。持ってきてくれ。
  ]],
  ru = [[
    {@delay 2}Привет, сынок. Давненько я тебе не звонил
    Мне нужно немного ископаемого топлива, чтобы запитать мой измельчитель древесины {@pause 30}
    Не мог бы ты привезти немного на своём грузовике?
    Спасибо!
  ]]
})

add_translation_string("vehicles_uncle_ben_dialogue_finish", {
  en = [[
    {@delay 2}What in tarnation..{@pause 30}
    You're already here! with just enough fuel!
    God bless you son.{@pause 40}
	I need another favour from you.{@pause 30}
	I need a crate delivered to a friend of mine in the desert.{@pause 30}
  ]],
  jp = [[
    {@delay 2}マジかよ……{@pause 30}もう終わらせちまったのか？
    大したもんだな、お前さんは。{@pause 40}
	そうだ。もうひとつ、頼みごとをしてもいいか？{@pause 30}
	そこの箱をダチの所に持っていって欲しいんだ。
    そいつは砂漠にいるから、よろしくな。{@pause 30}
  ]],
  ru = [[
    {@delay 2}Что, чёрт возьми.. {@pause 30}
    Ты уже здесь! С достаточным количеством топлива!
    Храни тебя Бог, сынок.{@pause 40}
	Мне нужна ещё одна услуга от тебя.{@pause 30}
	Мне нужно доставить ящик моему другу в пустыне.{@pause 30}
  ]]
})

add_translation_string("vehicles_uncle_ben_dialogue_finish2", {
  en = [[
    {@delay 2}Don't worry, I have a couple of quad bikes in the back.{@pause 20}
	Beware of bandits and remember..{@pause 10} 
	your tires are as tough as a mountain lion!{@pause 40}
	#Now You Listen To Me!#{@pause 40}
	Don't you dare open that crate.
  ]],
  jp = [[
    {@delay 2}ああ、心配するなって。そこに四駆があるから、それを使いな。{@pause 20}
	ダチの所までの道は危ないから、気を付けろよ？ああそうだ。それと……{@pause 10} 
	そいつのタイヤはめちゃくちゃ頑丈だから、その点は大丈夫さ。{@pause 40}
	#ああもうひとつ、大事なことを言い忘れてた。#{@pause 40}
	箱の中身は、絶対に見るんじゃねぇぞ。
  ]],
  ru = [[
    {@delay 2}Не волнуйся, у меня есть пара квадроциклов в багажнике.{@pause 20}
	Остерегайся бандитов и помни..{@pause 10} 
	твои шины прочные, как у горного льва!{@pause 40}
	#А теперь послушай меня!#.{@pause 40}
	Не смей открывать этот ящик.
  ]]
})

add_translation_string("vehicles_jose_name", {
  en = [[Jose]],
  jp = [[ホセ]],
  ru = [[Хосе]]
})

add_translation_string("vehicles_jose_dialogue_finish", {
  en = [[
    {@delay 2}There you are! {@pause 20}Drop the crate here amigo.{@pause 30}
    High price of gold you were carrying there.
    No wonder why the bandits attacked you!{@pause 30}
	I guess your uncle's debt is paid now..{@pause 30}
  ]],
  jp = [[
    {@delay 2}ヘイ、アミーゴ！ {@pause 20}箱はそこに置いてくれな。{@pause 30}
    実はな、それの中身は大金なんだ。
    分かっただろ？どうして野盗に襲われたか。{@pause 30}
	これで貸した分は返って来たかな……{@pause 30}
  ]],
  ru = [[
    {@delay 2}Вот ты где! {@pause 20}Брось ящик сюда, амиго.{@pause 30}
    Это барахло на вес золота, которое ты вёз.
    Неудивительно, почему бандиты напали на тебя!{@pause 30}
	Полагаю, долг твоего дяди теперь оплачен..{@pause 30}
  ]]
})

add_translation_string("vehicles_jose_dialogue_finish2", {
  en = [[
    {@delay 2}Hold on a second{@pause 30}
    My phone is ringing...
  ]],
  jp = [[
    {@delay 2}おっと？電話だ。
  ]],
  ru = [[
    {@delay 2}Подожди секунду{@pause 30}
    Мне звонят...
  ]]
})

add_translation_string("vehicles_eduardo_name", {
  en = [[Eduardo]],
  jp = [[エドゥアルド]],
  ru = [[Эдуардо]]
})

add_translation_string("vehicles_jose_dialogue_finish3", {
  en = [[
    {@delay 2}Elo Jose?!{@pause 30}
    The heat of the desert set the city on fire!{@pause 20}
	We need someone to help put it out!!
  ]],
  jp = [[
    {@delay 2}ホセ！大変だ！{@pause 30}
    この暑さで、街が大火事になってるぞ！{@pause 20}
	誰か、人を寄越してくれないか？
  ]],
  ru = [[
    {@delay 2}Эло Хосе?!{@pause 30}
    Жара пустыни вызвала пожар в городе!{@pause 20}
	Нам нужен кто-то, кто поможет его потушить!!!
  ]]
})

add_translation_string("vehicles_jose_dialogue_finish4", {
  en = [[
    {@delay 2}I think I know someone who's up for the job.
  ]],
  jp = [[
    {@delay 2}任せろ。ちょうどいいヤツがここにいる。
  ]],
  ru = [[
    {@delay 2}Мне кажется, я знаю человека, который подходит для этой работы.
  ]]
})

add_translation_string("vehicles_mayor_name", {
  en = [[Mayor]],
  jp = [[市長]],
  ru = [[Мэр]]
})

add_translation_string("vehicles_mayor_dialogue_finish", {
  en = [[
    {@delay 2}Goodness Gracious! {@pause 20}You saved our City!{@pause 20}
    Very Well done friend!{@pause 30}
    I can't possibly express enough gratitude!{@pause 30}
	You deserve to be rewarded.{@pause 30}
  ]],
  jp = [[
    {@delay 2}グラシアス！ありがとう！{@pause 20}あんたは街の英雄だ！{@pause 20}
    本当によくやってくれた。{@pause 30}
    何とお礼を言ったらいいか。{@pause 30}
	何か、お礼の品を渡せればいいんだが。{@pause 30}
  ]],
  ru = [[
    {@delay 2}Боже милостивый! {@pause 20}Ты спас наш город!{@pause 20}
    Очень хорошо получилось, друг!{@pause 30}
    Я не могу выразить словами свою благодарность!{@pause 30}
	Ты заслуживаешь награды.{@pause 30}
  ]]
})

add_translation_string("vehicles_mayor_dialogue_finish2", {
  en = [[
    {@delay 2}Here's a Medal as a token of our appreciation.{@pause 20}
  ]],
  jp = [[
    {@delay 2}よし。この勲章を受け取ってくれ。感謝のしるしだ。{@pause 20}
  ]],
  ru = [[
    {@delay 2}Вот медаль в знак нашей благодарности.{@pause 20}
  ]]
})

add_translation_string("vehicles_mayor_dialogue_finish3", {
  en = [[
    {@delay 2}We are currently trying to find a person who went missing.{@pause 20}
	We believe that he is lost in the Bawabi Sea{@pause 20}
	I believe that we could certainly use your help to find him!{@pause 40}
	However beware..{@pause 20} legends say that undocumented beasts
	dwell there.
  ]],
  jp = [[
    {@delay 2}ところで、この街で最近、行方不明者が出たんだ。{@pause 20}
	バワビ海のどこかを漂流してると思うんだが……{@pause 20}
	あんたの助けを借りることはできないか？{@pause 40}
	そうだ。これは噂なんだが……{@pause 20}
    あの海には、怪物が住んでるそうだ。
  ]],
  ru = [[
    {@delay 2}Сейчас мы пытаемся найти человека, который пропал без вести.{@pause 20}
	Мы полагаем, что он потерялся в море Баваби{@pause 20}
	Я считаю, что нам бы точно пригодилась твоя помощь, чтобы найти его!{@pause 40}
	Однако осторожно..{@pause 20} Легенды гласят, что недокументированные звери
	обитают там.
  ]]
})

add_translation_string("vehicles_island_dialogue_finish", {
  en = [[
    {@delay 2}You Made it! {@pause 20}Are you both alright?{@pause 20}
    Some crew members got eaten alive by those sea creatures!{@pause 30}
    There's no time to waste.{@pause 30} We are in enemy territory.{@pause 30}
	Hop on our plane and we'll be on our way.
  ]],
  jp = [[
    {@delay 2}でかした！{@pause 20}二人とも大丈夫か！？{@pause 20}
    仲間が何人か、あの怪物どもにやられちまった。{@pause 30}
    よし、逃げるぞ。{@pause 30}ここは敵のど真ん中だ。{@pause 30}
	そこに飛行機がある。操縦は任せたぞ！
  ]],
  ru = [[
    {@delay 2}Ты сделал это! {@pause 20}Вы оба в порядке?{@pause 20}
    Некоторые члены экипажа были заживо съедены этими морскими тварями!{@pause 30}
    Нельзя терять время.{@pause 30} Мы на вражеской территории.{@pause 30}
	Запрыгивайте в наш самолёт, и мы отправимся в путь.
  ]]
})

add_translation_string("vehicles_plane_dialogue_start", {
  en = [[
    {@delay 2}Help Help! We are under attack{@pause 20}
    Remember to click to fire your weapons!{@pause 30}
  ]],
  jp = [[
    {@delay 2}敵襲だ！{@pause 20}
    左クリックで機銃が撃てる。使ってくれ！{@pause 30}
  ]],
  ru = [[
    {@delay 2}Помогите-помогите! Нас атакуют{@pause 20}
    Не забывай нажимать на кнопку, чтобы стрелять из своего оружия!{@pause 30}
  ]]
})

add_translation_string("vehicles_plane_dialogue_finish1", {
  en = [[
    {@delay 2}I think we lost them. {@pause 20}
    What is this place? I've never seen it before.{@pause 30}
    The ground is black and volcanic.
  ]],
  jp = [[
    {@delay 2}どうにか撒いたか。{@pause 20}
    しかし、ここはどこだ？初めて来る場所だ。{@pause 30}
    地面が真っ黒。ここは火山か？
  ]],
  ru = [[
    {@delay 2}Кажись, мы их потеряли. {@pause 20}
    Что это за место? Я никогда не видел его раньше.{@pause 30}
    Земля чёрная и вулканическая.
  ]]
})

add_translation_string("vehicles_plane_ufos_start", {
  en = [[
    {@delay 2}What on earth are those??{@pause 20}
    On my! It's an alien invasion!{@pause 30}
    Keep moving. I'll call Nasa for help.
  ]],
  jp = [[
    {@delay 2}何っだこりゃ！！！{@pause 20}
    UFOだって！？まさか、宇宙人が攻めてきたのか！？{@pause 30}
    よし、これからNASAに連絡を入れる。その間、どうにか持ちこたえてくれ！
  ]],
  ru = [[
    {@delay 2}Это что, чёрт возьми, такое???{@pause 20}
    Да это же инопланетное вторжение!{@pause 30}
    Продолжай двигаться. Я позову на помощь Насу.
  ]]
})

add_translation_string("vehicles_nasa_name", {
  en = [[Nasa]],
  jp = [[NASA]],
  ru = [[Наса]]
})

add_translation_string("vehicles_ufos_dialogue_finish1", {
  en = [[
    {@delay 2}Hello. Nasa speaking{@pause 20}
    What seems to be your problem?
  ]],
  jp = [[
    {@delay 2}はい、こちらはNASAコールセンターです。{@pause 20}
    どうかされましたか？
  ]],
  ru = [[
    {@delay 2}Здравствуйте. Говорит Наса{@pause 20}
    Что за проблема у вас там?
  ]]
})

add_translation_string("vehicles_ufos_dialogue_finish2", {
  en = [[
    {@delay 2}Hello I'm the mayor of Sunnydale City{@pause 10}
    We are currently experiencing an Alien invasion{@pause 20}
	I'm not sure where we are exactly..
	but we could certainly use some help.
  ]],
  jp = [[
    {@delay 2}サニーデール市の市長だ。{@pause 10}
    宇宙人に追われて、見たこともない場所に来ちまった。{@pause 20}
	何とかしてヤツらを叩きのめしたい。支援を要請する！
  ]],
  ru = [[
    {@delay 2}Здравствуйте, я мэр города Саннидейл{@pause 10}
    В настоящее время мы переживаем вторжение инопланетян{@pause 20}
	Я не уверен, где именно мы находимся..
	но нам бы не помешала помощь.
  ]]
})

add_translation_string("vehicles_ufos_dialogue_finish3", {
  en = [[
    {@delay 2}Oh my. I hope you make it out alive!{@pause 10}
	We have to get to the bottom of this.
    We have a spare rocket at coordinates x=566 y=244.{@pause 30}
	You can use it to go to the aliens' home planet and defeat
	their queen.{@pause 40} However, you'll need someone to drive.
  ]],
  jp = [[
    {@delay 2}何ですって！承知しました。{@pause 10}
    x=566 y=244に向かってください。予備の宇宙ロケットが設置してあるはずです。{@pause 30}
	それで敵の母星に向かい、首領を叩いて下さい。{@pause 40} 
    ところで、そちらにロケットを操縦できる方はいらっしゃいますか？
  ]],
  ru = [[
    {@delay 2}О боже. Надеюсь, вы выберетесь живыми!{@pause 10}
	Мы должны разобраться в этом деле.
    У нас есть запасная ракета в координатах x=566 y=244.{@pause 30}
	Вы можете использовать её, чтобы отправиться на родную планету пришельцев и победить
	их королеву.{@pause 40} Однако вам понадобится кто-то, кто будет управлять ракетой.
  ]]
})

add_translation_string("vehicles_ufos_dialogue_finish4", {
  en = [[
    {@delay 2}Alright. Thank you very much Nasa.{@pause 10}
	I'm certain that my friend here can drive the 
	rocket without problems. 
	I'm sure we'll figure something out.
  ]],
  jp = [[
    {@delay 2}大丈夫だ。ここにはスゴ腕のドライバーがいる。
	こいつなら、ロケットだろうとすぐにマスターできるはずだ。{@pause 10}
    協力感謝する！あとは任せてくれ！
  ]],
  ru = [[
    {@delay 2}Хорошо. Большое спасибо Наса.{@pause 10}
	Я без сомнения уверен, что мой друг сможет управлять 
	ракетой без проблем. 
	Я уверен, что мы что-нибудь придумаем.
  ]]
})

add_translation_string("vehicles_dialogue_leave", {
  en = [[> Continue <]],
  jp = [[> Continue <]],
  ru = [[> Далее <]]
})

ModTextFileSetContent("data/translations/common.csv", contents)

--Addition of Custom sounds:
ModRegisterAudioEventMappings("mods/vehicles/files/sound/GUIDs.txt")

-- Overwrite death sound to disable it
GamePlaySound("mods/vehicles/files/sound/death.bank", "dummy_sound", 0, 0)

-- dofile_once("mods/vehicles/lib/dialogsystem/init.lua")("mods/vehicles/lib/dialogsystem")
dofile_once("mods/vehicles/lib/dialogsystem/init.lua")("mods/vehicles/lib/dialogsystem", {distance_to_close = 2000})

local nxml = dofile_once("mods/vehicles/lib/nxml.lua")
--set collapsed concrete strength
local content = ModTextFileGetContent("data/materials.xml")
local xml = nxml.parse(content)
for element in xml:each_child() do
  if element.attr.name == "sand_surface" then
    -- element.attr.liquid_viscosity = 50
	-- element.attr.liquid_gravity = 0.1
	element.attr.liquid_sticks_to_ceiling = 1
	element.attr.liquid_sand = 1
	element.attr.cell_type = "liquid"
	element.attr.density = 60
  end
  if element.attr.name == "water_salt" then
	element.attr.ignore_self_reaction_warning = 1
  end
end
ModTextFileSetContent("data/materials.xml", tostring(xml))

function OnPlayerSpawned(player_entity)

  if (GlobalsGetValue("vehicles_mod_load_done", 0) == "1") then
    return
  end
  
  local x, y = EntityGetTransform(player_entity)
  local vehicle = EntityLoad("mods/vehicles/files/truck/truck_spawner.xml", MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_X" ), MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_Y" ))
  local dialogue = EntityLoad("mods/vehicles/files/truck/dialogue.xml", MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_X" ), MagicNumbersGetValue( "DESIGN_PLAYER_START_POS_Y" ))
  
  GlobalsSetValue("vehicles_mod_load_done", "1")
end

function OnWorldPreUpdate()

	--always daytime
	local world_state_entity = GameGetWorldStateEntity()
	edit_component( world_state_entity, "WorldStateComponent", function(comp,vars)
		vars.time = 0
		vars.time_dt = 0
		vars.fog = 0
		vars.fog_target = 0
		vars.fog_target_extra = 0
		vars.rain = 0
		vars.rain_target = 0
		vars.rain_target_extra = 0
		vars.intro_weather = 1
		vars.open_fog_of_war_everywhere = 1
	end)

    --GUI
    local id = 2
    local function new_id()
      id = id + 1
      return id
    end
	
    gui = gui or GuiCreate()
    GuiStartFrame(gui)
	GuiLayoutBeginVertical(gui, 90, 2)
	
    if GuiButton(gui, new_id(), 0, 0, "Reset") then
		if GlobalsGetValue("vehicles_respawn_in_progress", "0") == "0" then
			SetTimeOut(0, "mods/vehicles/files/restart.lua", "clear")
			SetTimeOut(1, "mods/vehicles/files/restart.lua", "respawn")
			GlobalsSetValue("vehicles_respawn_in_progress", "1")
		end
    end
    GuiLayoutEnd(gui)
	
end